// SimULATIon.cpp
//
//////////////////////////////////////////////////////////////////////

#include "simset.h"
#include <string>
#include "thread.h"
#include "process.h"
#include <signal.h>
#include <assert.h>
#include <unistd.h>

//////////////////////////////////////////////////////////////////////
// Thread.cpp: implementation of the CThread class.
//
//////////////////////////////////////////////////////////////////////

CThread::CThread ()
{
  signal (SIGPIPE, SIG_IGN);
  threadID = 0;
}

CThread::~CThread ()
{
  if (threadID) pth_cancel (threadID);
  // zruseni vlakna v pripade, ze neni ukonceno pred volanim destruktoru
};


// obnovi beh vlakna
void
CThread::Resume ()
{
  if (threadID == 0)		// vlakno dosud nebylo vytvoreno
    {				// zadna akce
      return;
    }
  int res = pth_resume (threadID);
  while (res != TRUE)
    {
      usleep (10);
      res = pth_resume (threadID);
    }
  return;
};

void *
SuspendProc (void *thread)
{
  CThread *t = (CThread *) thread;
	int r;

  //while (true)
  //{
    //printf("suspending sel\n");
  //	r = pth_suspend(pth_self());
	//while (r != TRUE)
	//	r = pth_suspend( pth_self() );

  	 r = pth_suspend (t->threadID);
	 while (r != TRUE )
	 	r = pth_suspend(t->threadID);
  //}
  //return 0;
  //pth_join(t->threadID,NULL);
  pth_exit(0);
}

// pozastavi beh vlakna
void
CThread::Suspend ()
{
  // create thread that suspends me...
  pth_attr_t attr;
  attr = pth_attr_new ();
  pth_attr_set (attr, PTH_ATTR_JOINABLE, FALSE);
  pth_attr_set (attr, PTH_ATTR_CANCEL_STATE, PTH_CANCEL_ASYNCHRONOUS);
  //pth_t st = pth_spawn (attr, &SuspendProc, (void *) this);
  suspTh = pth_spawn (attr, &SuspendProc, (void *) this);
  
  pth_attr_destroy(attr);
  pth_yield (suspTh);

	
  return;
};


//Init vytvori pro objekt CThread jeho provadeci tok - vlakno
//tim je staticka metoda ThreadProc, ktere se preda ukazatel this

void
CThread::InitThread ()
{

  int res;
  pth_attr_t attr;
  attr = pth_attr_new ();
  pth_attr_set (attr, PTH_ATTR_NAME, "fred");
  pth_attr_set (attr, PTH_ATTR_JOINABLE, TRUE);
  pth_attr_set (attr, PTH_ATTR_CANCEL_STATE, PTH_CANCEL_ASYNCHRONOUS);
  threadID = pth_spawn (attr, &CProcess::iq, (void *) this);
  pth_attr_destroy(attr);
  pth_suspend (threadID);
};


void CThread::SuspAnother(CThread *th)
{
	th->Suspend();
	//pth_cancel(th->suspTh);
	
}
